﻿using System;
using System.Windows.Input;

namespace WpfApplication1 {
    public class MyViewModel {
        private MyCommand _TestCommand;
        public ICommand TestCommand {
            get {
                if (_TestCommand == null) {
                    _TestCommand = new MyCommand(x => {
                        System.Windows.MessageBox.Show((string)x);
                    });
                }
                return _TestCommand;
            }
        }

        class MyCommand : ICommand {

            Action<object> action;
            internal MyCommand(Action<object> action) {
                this.action = action;
            }


            #region ICommand Members

            public bool CanExecute(object parameter) {
                return true;
            }

            public event EventHandler CanExecuteChanged;

            public void Execute(object parameter) {
                action(parameter);
            }

            #endregion
        }
    }
}
